function [F,L] = ffun_sd_ekf_jacobian(x,input,d)
% This file includes current dynamics
mu_x = 0.2;
mu_y = 0.2;

[Ax,Ad] = jacobi_modulus(x(1:6),x(7:8));

F = zeros(8,8);
F(1:6,1:6) = Ax; 
F(1:6,7:8) = Ad;
F(7:8,7:8) = -diag([mu_x mu_y]);

L = zeros(8,2);
L(7:8,1:2) = eye(2);
