if k == 1;
    ekf_me_fu_off = Prob.estimation.ekf_measurement_function_offline; 
    ekf_in_off = Prob.estimation.ekf_integrator_offline;
    ekf_co_off = Prob.estimation.ekf_constraints_offline;
    ekf_up_ja_off = Prob.estimation.ekf_update_jacobian_offline;
    ekf_me_ja_off = Prob.estimation.ekf_measurement_jacobian_offline;
    

    ekf_Q_off = Prob.estimation.ekf_Q_offline; % Process noise covariance
    ekf_R_off = Prob.estimation.ekf_R_offline; % Process noise covariance

    ekf_me_off = strcat(Prob.estimation.ekf_measurements_offline,'(:,k)');
    ekf_pa_off = Prob.estimation.ekf_parameters_offline;
else
    [Prob.result.x_ekf_off(:,k),Prob.result.X_ekf_off(:,:,k)] =...
        feval(@ekf,ekf_in_off,ekf_up_fu_off,ekf_me_fu_off,...
        ekf_up_ja_off,ekf_me_ja_off,ekf_co_off,...
        eval(ekf_mea_off),Prob.result.x_ekf_ukf(:,k-1),Prob.result.u(:,k-1),...
        eval(ekf_pa_off),Prob.result.X_ekf_off(:,:,k-1),ekf_Q_off,ekf_R_off,Ts);
end