if k == 1; 
    MPC_time = 0; 
    Prob.result.u = zeros(n_u,samples);  
    Prob.controller.z_prev_predicted = result.x_sim(:,k);
else
    Prob.controller.z_prev_predicted = result.z_predicted(:,1,k-1);
end
    

if strcmp(Prob.estimation.S_ESTIMATE_ONLINE,'On')
    Prob.controller.x_0 = eval(Prob.estimation.s_estimate);
else
    Prob.controller.x_0 = result.x_sim(:,k);
end % initial prediction state

if strcmp(Prob.estimation.D_ESTIMATE_ONLINE,'On')
    Prob.controller.d_0 = eval(Prob.estimation.d_estimate);
else Prob.controller.d_0 = result.d_sim_ned(:,k); 
end % current estimate

if strcmp(Prob.estimation.B_ESTIMATE_ONLINE,'On')
    Prob.controller.b_0 = eval(Prob.estimation.b_estimate);
else Prob.controller.b_0 = zeros(3,1); 
end % Wave-feedforward


if k > 1; u_0 = [u(n_u+1:end,k-1); u(end-n_u+1:end,k-1)]; % hotstart
else u_0 = u(:,k); end
tic;

[u(:,k),result] = feval(Prob.controller.optimization_function,u_0,Prob,result);

MPC_time = MPC_time + toc;
