if k == 1
    n_s = Prob.estimation.ukf_ns_offline;
    samples = Prob.simulation.samples;
    ukf_al_off = Prob.estimation.ukf_algorithm_offline;
    ukf_up_fu_off = Prob.estimation.ukf_update_function_offline;
    ukf_me_fu_off = Prob.estimation.ukf_measurement_function_offline;
    ukf_in_off = Prob.estimation.ukf_integrator_offline;
    ukf_co_off = Prob.estimation.ukf_constraints_offline;

    ukf_Q_off = Prob.estimation.ukf_Q_offline; % Process noise covariance
    ukf_R_off = Prob.estimation.ukf_R_offline; % Process noise covariance


    X_ukf_0_offline = Prob.estimation.X_ukf_0_offline;

    n_ukf = length(ukf_al_off);
    for ukf_number = 1:n_ukf
        if  Prob.estimation.ukf_ny_offline{ukf_number} == 3
            ukf_me_off{ukf_number} = 'result.y_sim_pose(:,k)';
        else
            ukf_me_off{ukf_number} = 'result.y_sim_full(:,k)';
        end
        ukf_pa_off{ukf_number} = Prob.estimation.ukf_parameters_offline{ukf_number};

       
        result.X_ukf_offline{ukf_number} = zeros(n_s{ukf_number},n_s{ukf_number},samples);
        result.X_ukf_offline{ukf_number}(:,:,1) = X_ukf_0_offline{ukf_number};
        result.x_ukf_offline{ukf_number} = zeros(n_s{ukf_number},samples);
        result.x_ukf_offline{ukf_number}(1:n_x,1) = [Prob.simulation.eta_0; zeros(3,1)];
        if n_s{ukf_number} > 6 % estimert straum
            result.x_ukf_offline{ukf_number}(n_x+1:n_x+2,1) = Prob.estimation.d_0;
        end
    end
else
    for ukf_number = 1:n_ukf
        [result.x_ukf_offline{ukf_number}(:,k),result.X_ukf_offline{ukf_number}(:,:,k)] =...
            feval(ukf_al_off{ukf_number},ukf_in_off{ukf_number},...
            ukf_up_fu_off{ukf_number},ukf_me_fu_off{ukf_number},...
            ukf_co_off{ukf_number},eval(ukf_me_off{ukf_number}),...
            result.x_ukf_offline{ukf_number}(:,k-1),result.u(:,k-1),eval(ukf_pa_off{ukf_number}),...
            result.X_ukf_offline{ukf_number}(:,:,k-1),...
            ukf_Q_off{ukf_number},ukf_R_off{ukf_number},ukf_number,Ts);
    end
end
