if k == 1
    n_s = Prob.estimation.ukf_ns_online;
    ukf_al_on = Prob.estimation.ukf_algorithm_online; 
    ukf_up_fu_on = Prob.estimation.ukf_update_function_online;
    ukf_me_fu_on = Prob.estimation.ukf_measurement_function_online; 
    ukf_in_on = Prob.estimation.ukf_integrator_online;
    ukf_co_on = Prob.estimation.ukf_constraints_online;

    ukf_Q_on = Prob.estimation.ukf_Q_online; % Process noise covariance
    ukf_R_on = Prob.estimation.ukf_R_online; % Process noise covariance

    ukf_pa_on = Prob.estimation.ukf_parameters_online;
    
    X_ukf_0_online = Prob.estimation.X_ukf_0_online;
    
    if  Prob.estimation.ukf_ny_online == 3
        ukf_me_on = 'result.y_sim_pose(:,k)';
    else
        ukf_me_on = 'result.y_sim_full(:,k)';
    end

    result.X_ukf_online = zeros(n_s,n_s,samples);
    result.X_ukf_online(:,:,1) = X_ukf_0_online;
    result.x_ukf_online = zeros(n_s,samples);
    result.x_ukf_online(1:n_x,1) = [Prob.simulation.eta_0; zeros(3,1)];
    if n_s > 6 % estimert straum
        result.x_ukf_offline(n_x+1:n_x+2,1) = Prob.estimation.d_0;
    end    
else
    [result.x_ukf_online(:,k),result.X_ukf_online(:,:,k)] =...
        feval(ukf_al_on,ukf_in_on,ukf_up_fu_on,ukf_me_fu_on,...
        ukf_co_on,eval(ukf_me_on),result.x_ukf_online(:,k-1),...
        result.u(1:3,k-1),eval(ukf_pa_on),result.X_ukf_online(:,:,k-1),...
        ukf_Q_on,ukf_R_on,1,Ts);
end