function y = constraints_velocity_current(x)

nu_max = [15; 15; 8*pi/180];
nu_min = -[15; 15; 8*pi/180];

nu_cmin = -[1; 1];
nu_cmax = [1; 1];

[n_x,n_s] = size(x);
for k = 1:n_s
x(4:6,k) = min(nu_max,x(4:6,k));
x(4:6,k) = max(nu_min,x(4:6,k));

if n_x > 6
    x(7:8,k) = max(nu_cmin,x(7:8,k));
    x(7:8,k) = min(nu_cmax,x(7:8,k));
end

end

y = x;

