function y = constraints_velocity_current_waves(x)

nu_max = [15; 15; 8*pi/180];
nu_min = -[15; 15; 8*pi/180];

nu_cmin = -[1.5; 1.5];
nu_cmax = [1.5; 1.5];

[n_x,n_s] = size(x);
for k = 1:n_s
x(4:6,k) = min(nu_max,x(4:6,k));
x(4:6,k) = max(nu_min,x(4:6,k));

if n_x > 6 %
    x(7:8,k) = max(nu_cmin,x(7:8,k));
    x(7:8,k) = min(nu_cmax,x(7:8,k));
end

if n_x > 8 %
    wf_min = -[1; 1; 1*pi/180];
    wf_max = [1; 1; 1*pi/180];
    x(12:14,k) = max(wf_min,x(12:14,k));
    x(12:14,k) = min(wf_max,x(12:14,k));
end

disp('constraints')
x(12:14,k)


if n_x == 17
    x(15,k) = min(0,x(15,k));
%     x(15,k) = max(-1e4,x(15,k));
    
    x(16,k) = min(0,x(16,k));
%     x(16,k) = max(-2e5,x(16,k));
    
    x(17,k) = max(0,x(17,k));
%     x(17,k) = min(1e6,x(17,k));
end

end

y = x;

