function y = constraints_velocity_waves(x)

nu_max = [15; 15; 8*pi/180];
nu_min = -[15; 15; 8*pi/180];

[n_x,n_s] = size(x);
for k = 1:n_s
x(4:6,k) = min(nu_max,x(4:6,k));
x(4:6,k) = max(nu_min,x(4:6,k));

if n_x == 15
    x(13,k) = max(0,x(13,k));
    x(14,k) = min(0,x(14,k));
    x(15,k) = max(0,x(15,k));
end

end

y = x;

