function [x,m,n] = mat2vec(A)
%
% [x,m,n] = mat2vec(A,m,n)
%
% Function that takes a matrix A and creates a vector.
% 
% Inputs:
% A - Matrix
%
% Outputs:
% x - vector containing elements of A
% m - number of rows of A
% n - number of columns of A

[m,n] = size(A);
x = zeros(m*n,1);

for k = 1:m*n
    x(k) = A(k);
end