
n2 = 200;
n = 180;
y1 = -1.5*ones(1,n2);
i = linspace(-pi/2,5*pi/6,n+1);


y1(1:n) = -sin(i(1:end-1))-1;
y2 = zeros(size(y1));
for k = 1:n2
  y2(k) = -y1(n2+1-k);
end

z = [y2 y1];
t = linspace(-1,1,length(z));
close all;
figure(1)
hold on;
line(zeros(1,101),-2.5:5/100:2.5);
line(-1:2/100:1,zeros(1,101));
plot(t,z,'k-');
plot(0,0,'r*');
plot(-0.68,2,'r^');
plot(0.68,-2,'rv');
legend('f(x)','Saddle point','Maximum','Minimum')
ylim([-2.5 2.5]);
ylabel('f(x)');
xlabel('x');
print -dpng -r300 -f1 opt_points
close(1);