function [y_real,y_est,x_est] = decoupled_pe(lin_par,abs_par,third_par,Name,x_L,x_U,t)

x_0 = [0 0];
JacPattern = [1 1];

y_real = lin_par*t + abs_par*(abs(t).*t) + third_par*t.^3;

Prob = clsAssign('residual_function_decoupled', 'residual_gradient_decoupled', JacPattern, x_L, x_U, Name, x_0, y_real, t);
Result = tomRun('clsSolve',Prob,3,0);

x_est = Result.x_k;

y_est = x_est(1)*t + x_est(2)*t.^3;
