if k == 1;
    n_s = Prob.estimation.ekf_ns_offline;
    samples = Prob.simulation.samples;
    ekf_up_fu_off = Prob.estimation.ekf_update_function_offline;
    ekf_me_fu_off = Prob.estimation.ekf_measurement_function_offline; 
    ekf_in_off = Prob.estimation.ekf_integrator_offline;
    ekf_co_off = Prob.estimation.ekf_constraints_offline;
    ekf_up_ja_off = Prob.estimation.ekf_update_jacobian_offline;
    ekf_me_ja_off = Prob.estimation.ekf_measurement_jacobian_offline;
    

    ekf_Q_off = Prob.estimation.ekf_Q_offline; % Process noise covariance
    ekf_R_off = Prob.estimation.ekf_R_offline; % Process noise covariance
    X_ekf_0_offline = Prob.estimation.X_ekf_0_offline;

    
    ekf_me_off = 'result.y_sim_pose(:,k)';
    ekf_pa_off = Prob.estimation.ekf_parameters_offline;
        
    result.X_ekf_offline = zeros(n_s,n_s,samples);
    result.X_ekf_offline(:,:,1) = X_ekf_0_offline;
    result.x_ekf_offline = zeros(n_s,samples);
    result.x_ekf_offline(1:n_x,1) = [Prob.simulation.eta_0; zeros(3,1)];
    if n_s > 6 % estimert straum
        result.x_ekf_offline(n_x+1:n_x+2,1) = Prob.estimation.d_0;
    end    
else
    [result.x_ekf_offline(:,k),result.X_ekf_offline(:,:,k)] =...
        feval(@ekf,ekf_in_off,ekf_up_fu_off,ekf_me_fu_off,...
        ekf_up_ja_off,ekf_me_ja_off,ekf_co_off,...
        eval(ekf_me_off),result.x_ekf_offline(:,k-1),result.u(:,k-1),...
        eval(ekf_pa_off),result.X_ekf_offline(:,:,k-1),ekf_Q_off,ekf_R_off,Ts);
end