if k == 1
    ukf_algorithm = Prob.estimation.ukf_algorithm; ukf_update_function = Prob.estimation.ukf_update_function;
    ukf_measurement_function = Prob.estimation.ukf_measurement_function; ukf_integrator = Prob.estimation.ukf_integrator;
    ukf_constraints = Prob.estimation.ukf_constraints;

    ukf_Q = Prob.estimation.ukf_Q; % Process noise covariance
    ukf_R = Prob.estimation.ukf_R; % Process noise covariance

    n_ukf = length(ukf_algorithm);
    measurements = cell(1,n_ukf);
    parameters = cell(1,n_ukf);
    for ukf_number = 1:n_ukf
        measurements{ukf_number} = strcat(Prob.estimation.ukf_measurements{ukf_number},'(:,k)');
        parameters{ukf_number} = Prob.estimation.ukf_parameters{ukf_number};
    end
else
    for ukf_number = 1:n_ukf
        [Prob.result.x_ukf{ukf_number}(:,k),Prob.result.X_ukf{ukf_number}(:,:,k)] =... 
        feval(ukf_algorithm{ukf_number},ukf_integrator{ukf_number},...
        ukf_update_function{ukf_number},ukf_measurement_function{ukf_number},...
        ukf_constraints{ukf_number},eval(measurements{ukf_number}),...
        Prob.result.x_ukf{ukf_number}(:,k-1),tau(:,k-1),eval(parameters{ukf_number}),...
        Prob.result.X_ukf{ukf_number}(:,:,k-1),...
        ukf_Q{ukf_number},ukf_R{ukf_number},ukf_number,Ts);
    end
end