    Prob.controller.n_p = 1;
    wb_x = 0.25; wb_y = 0.15; wb_psi = 1.5*pi/180;
    eta_x = 0.790; eta_y = 0.790; eta_psi = 0.790;
    wn_x = wb_x/sqrt(1-2*eta_x^2 + sqrt(4*eta_x^4 - 4*eta_x^2 + 2));
    wn_y = wb_y/sqrt(1-2*eta_y^2 + sqrt(4*eta_y^4 - 4*eta_y^2 + 2));
    wn_psi = wb_psi/sqrt(1-2*eta_psi^2 + sqrt(4*eta_psi^4 - 4*eta_psi^2 + 2));
    m_x = cs.m+cs.X_udot; m_y = cs.m+cs.Y_vdot; m_psi = cs.I_z+cs.N_rdot;
    d_x = cs.X3_u; d_y = cs.Y3_v; d_psi = cs.N3_r;
    Km_x = 0; Km_y = 0; Km_psi = 0;
    Kp_x = (m_x + Km_x)*wn_x^2; Kp_y = (m_y + Km_y)*wn_y^2;  Kp_psi = (m_psi + Km_psi)*wn_psi^2;
    Kd_x = ((m_x + Km_x)*wn_x*2*eta_x - d_x); Kd_y = ((m_y + Km_y)*wn_y*2*eta_y - d_y);  Kd_psi = ((m_psi + Km_psi)*wn_psi*2*eta_psi - d_psi);
    Ki_x = wn_x/10*Kp_x; Ki_y = wn_y/10*Kp_y; Ki_psi = wn_psi/10*Kp_psi;

    Prob.controller.Kp = diag([Kp_x; Kp_y; Kp_psi]);
    Prob.controller.Kd = diag([Kd_x; Kd_y; Kd_psi]);
    Prob.controller.Ki = diag([Ki_x; Ki_y; Ki_psi]);