function A = vec2mat(x,m,n)
%
% A = vec2mat(x,m,n)
%
% Function that takes a matrix A and creates a vector.
% 
% Inputs:
% x - vector containing elements of A
% m - number of rows of A
% n - number of columns of A
%
% Outputs:
% A - Matrix

A = zeros(m,n);

for k = 1:m*n
    A(k) = x(k);
end